summaryrefslogtreecommitdiff
path: root/tools
diff options
context:
space:
mode:
authorThomas Haller <thaller@redhat.com>2023-02-28 07:51:07 +0100
committerThomas Haller <thaller@redhat.com>2023-02-28 13:05:47 +0100
commitfdec6a97e85987359fdf26c367b00a1f8ac27be3 (patch)
tree5b98b5e17962238ad90a9bc3f2d6885f2f9dbfe2 /tools
parent4d325bafe193dc1fc4fbd0beabae7bb6ab8901bc (diff)
downloadNetworkManager-fdec6a97e85987359fdf26c367b00a1f8ac27be3.tar.gz
vapi: add test for consistency of "vapi/NM-1.0.metadata"
Diffstat (limited to 'tools')
-rwxr-xr-xtools/check-vapi.sh25
1 files changed, 25 insertions, 0 deletions
diff --git a/tools/check-vapi.sh b/tools/check-vapi.sh
new file mode 100755
index 0000000000..da640cfd0f
--- /dev/null
+++ b/tools/check-vapi.sh
@@ -0,0 +1,25 @@
+#!/bin/bash
+
+set -e
+
+die() {
+ printf "%s\n" "$*" >&2
+ exit 1
+}
+
+cd "$(dirname "$(readlink -f "$0")")/.." || die "cannot change to srcdir"
+
+VAPI=./vapi/NM-1.0.metadata
+
+for s in $(grep -r -h '#define \+\<NM_SETTING_.*SETTING_NAME\>' -- ./src/libnm-core-public/ \
+ | sed -n 's/^#define \+NM_\(SETTING_[A-Z0-9_]\+\)_SETTING_NAME\> \+.*/\1/p') ; do
+ grep -q "^$s" -- "$VAPI" || die "didn't see '$s' in \"$VAPI\""
+done
+
+for f in ./src/libnm-client-public/nm-device-*.h ; do
+ D=( $(sed -n 's/^#define \+NM_IS_DEVICE_\([A-Z0-9_]\+\)_CLASS\>(.*/\1/p' "$f") )
+ test ${#D[@]} = 1 || die "did not detect device in \"$f\""
+ s="${D[0]}"
+ c="$(grep -c "^DEVICE_${s}_\* *parent=" -- "$VAPI")"
+ test "$c" = 1 || die "didn't see device '$s' in \"$VAPI\""
+done